﻿using NUnit.Framework;

namespace FizzBuzzKata.Tests
{
    [TestFixture]
    public class KataTests
    {
        [Test]
        [TestCase(3)]
        [TestCase(9)]
        [TestCase(333)]
        public void GivenNumberDivisibleBy3_WhenFizzBuzzIt_ReturnsFizz(int number)
        {
            var fizz = Kata.SingleFizzBuzz(number);
            Assert.That(fizz, Is.EqualTo("Fizz"));
        }

        [Test]
        [TestCase(5)]
        [TestCase(50)]
        [TestCase(500)]
        public void GivenNumberDivisibleBy5_WhenFizzBuzzIt_ReturnsBuzz(int number)
        {
            var fizz = Kata.SingleFizzBuzz(number);
            Assert.That(fizz, Is.EqualTo("Buzz"));
        }

        [Test]
        [TestCase(15)]
        [TestCase(45)]
        [TestCase(60)]
        public void GivenNumberDivisibleBy3And5_WhenFizzBuzzIt_ReturnsFizzBuzz(int number)
        {
            var fizzBuzz = Kata.SingleFizzBuzz(number);
            Assert.That(fizzBuzz, Is.EqualTo("FizzBuzz"));
        }

        [Test]
        [TestCase(2)]
        [TestCase(7)]
        [TestCase(101)]
        public void GivenNumberNotDivisibleBy3Or5_WhenFizzBuzzIt_ReturnsNumber(int number)
        {
            var numberString = Kata.SingleFizzBuzz(number);
            Assert.That(numberString, Is.EqualTo(number.ToString()));
        }
    }
}
